Index: main/kofacustom.dspg/trunk/src/kofacustom/dspg/interswitch/browser.py
===================================================================
--- main/kofacustom.dspg/trunk/src/kofacustom/dspg/interswitch/browser.py	(revision 16761)
+++ main/kofacustom.dspg/trunk/src/kofacustom/dspg/interswitch/browser.py	(revision 16762)
@@ -332,8 +332,8 @@
             # amount_auth is being ignored. However, the sum of all split payments
             # must coincide with the amount_auth configured in students/utils.py
-            xmldict['amt1'] = 100 * 1000
-            xmldict['amt2'] = 100 * 500
+            xmldict['amt1'] = 100 * 2000
+            xmldict['amt2'] = 100 * 1000
             xmldict['amt3'] = 100 * 900
-            xmldict['amt4'] = 100 * 500
+            xmldict['amt4'] = 100 * 1000
 
             xmltext = """<payment_item_detail>
Index: main/kofacustom.dspg/trunk/src/kofacustom/dspg/interswitch/tests.py
===================================================================
--- main/kofacustom.dspg/trunk/src/kofacustom/dspg/interswitch/tests.py	(revision 16761)
+++ main/kofacustom.dspg/trunk/src/kofacustom/dspg/interswitch/tests.py	(revision 16762)
@@ -227,14 +227,14 @@
         self.browser.getControl("Create ticket").click()
         self.assertMatches('...ticket created...', self.browser.contents)
-        self.assertTrue('<span>3150.0</span>'  in self.browser.contents)
-        self.payment_url = self.browser.url
-        self.browser.getLink("Pay via Interswitch", index=0).click()
-        self.assertTrue('<item_detail item_id="1" item_name="SUG" item_amt="100000" bank_id="11" acct_num="0038079930" />'
-            in self.browser.contents)
-        self.assertTrue('<item_detail item_id="2" item_name="Students Welfare" item_amt="50000" bank_id="11" acct_num="0037892949" />'
+        self.assertTrue('<span>5150.0</span>'  in self.browser.contents)
+        self.payment_url = self.browser.url
+        self.browser.getLink("Pay via Interswitch", index=0).click()
+        self.assertTrue('<item_detail item_id="1" item_name="SUG" item_amt="200000" bank_id="11" acct_num="0038079930" />'
+            in self.browser.contents)
+        self.assertTrue('<item_detail item_id="2" item_name="Students Welfare" item_amt="100000" bank_id="11" acct_num="0037892949" />'
             in self.browser.contents)
         self.assertTrue('<item_detail item_id="3" item_name="Anti-Cult Book" item_amt="90000" bank_id="11" acct_num="0037892949" />'
             in self.browser.contents)
-        self.assertTrue('<item_detail item_id="4" item_name="NADESSTU" item_amt="50000" bank_id="11" acct_num="0036375968" />'
+        self.assertTrue('<item_detail item_id="4" item_name="NADESSTU" item_amt="100000" bank_id="11" acct_num="0036375968" />'
             in self.browser.contents)
 
Index: main/kofacustom.dspg/trunk/src/kofacustom/dspg/students/tests/test_utils.py
===================================================================
--- main/kofacustom.dspg/trunk/src/kofacustom/dspg/students/tests/test_utils.py	(revision 16761)
+++ main/kofacustom.dspg/trunk/src/kofacustom/dspg/students/tests/test_utils.py	(revision 16762)
@@ -87,5 +87,5 @@
         self.assertEqual(payment.p_level, 200)
         self.assertEqual(payment.p_session, 2005)
-        self.assertEqual(payment.amount_auth, 3150.0)
+        self.assertEqual(payment.amount_auth, 5150.0)
         # Students can pay school fee if dep_sug and gns dues have been paid first.
         error, payment = utils.setPaymentDetails('schoolfee',self.student)
Index: main/kofacustom.dspg/trunk/src/kofacustom/dspg/students/utils.py
===================================================================
--- main/kofacustom.dspg/trunk/src/kofacustom/dspg/students/utils.py	(revision 16761)
+++ main/kofacustom.dspg/trunk/src/kofacustom/dspg/students/utils.py	(revision 16762)
@@ -281,5 +281,5 @@
                 return _(u'No bed allocated.'), None
         elif category == 'dep_sug':
-            amount = 3150.0 # includes GATEWAY_AMT
+            amount = 5150.0 # includes GATEWAY_AMT
             #if student.faccode == 'SPAT':
             #    amount = 1650.0 # includes GATEWAY_AMT