Index: main/kofacustom.dspg/trunk/src/kofacustom/dspg/interswitch/browser.py
===================================================================
--- main/kofacustom.dspg/trunk/src/kofacustom/dspg/interswitch/browser.py	(revision 16793)
+++ main/kofacustom.dspg/trunk/src/kofacustom/dspg/interswitch/browser.py	(revision 16794)
@@ -350,7 +350,7 @@
             # amount_auth is being ignored. However, the sum of all split payments
             # must coincide with the amount_auth configured in students/utils.py
-            xmldict['amt1'] = 100 * 800
-            xmldict['amt2'] = 100 * 1000
-            xmldict['amt3'] = 100 * 500
+            xmldict['amt1'] = 100 * 1000
+            xmldict['amt2'] = 100 * 1000
+            xmldict['amt3'] = 100 * 1000
 
             xmltext = """<payment_item_detail>
@@ -366,6 +366,6 @@
             # amount_auth is being ignored. However, the sum of all split payments
             # must coincide with the amount_auth configured in students/utils.py
-            xmldict['amt1'] = 100 * 300
-            xmldict['amt2'] = 100 * 500
+            xmldict['amt1'] = 100 * 1000
+            xmldict['amt2'] = 100 * 1000
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
@@ -379,6 +379,6 @@
             # amount_auth is being ignored. However, the sum of all split payments
             # must coincide with the amount_auth configured in students/utils.py
-            xmldict['amt1'] = 100 * 500
-            xmldict['amt2'] = 100 * 500
+            xmldict['amt1'] = 100 * 1000
+            xmldict['amt2'] = 100 * 1000
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
@@ -392,6 +392,6 @@
             # amount_auth is being ignored. However, the sum of all split payments
             # must coincide with the amount_auth configured in students/utils.py
-            xmldict['amt1'] = 100 * 500
-            xmldict['amt2'] = 100 * 500
+            xmldict['amt1'] = 100 * 1000
+            xmldict['amt2'] = 100 * 1000
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
@@ -405,6 +405,6 @@
             # amount_auth is being ignored. However, the sum of all split payments
             # must coincide with the amount_auth configured in students/utils.py
-            xmldict['amt1'] = 100 * 500
-            xmldict['amt2'] = 100 * 500
+            xmldict['amt1'] = 100 * 1000
+            xmldict['amt2'] = 100 * 1000
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
@@ -419,6 +419,6 @@
             # must coincide with the amount_auth configured in students/utils.py
             xmldict['amt1'] = 100 * 3000
-            xmldict['amt2'] = 100 * 500
-            xmldict['amt3'] = 100 * 500
+            xmldict['amt2'] = 100 * 1000
+            xmldict['amt3'] = 100 * 1000
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
@@ -433,6 +433,6 @@
             # amount_auth is being ignored. However, the sum of all split payments
             # must coincide with the amount_auth configured in students/utils.py
-            xmldict['amt1'] = 100 * 500
-            xmldict['amt2'] = 100 * 500
+            xmldict['amt1'] = 100 * 1000
+            xmldict['amt2'] = 100 * 1000
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
@@ -446,6 +446,6 @@
             # amount_auth is being ignored. However, the sum of all split payments
             # must coincide with the amount_auth configured in students/utils.py
-            xmldict['amt1'] = 100 * 500
-            xmldict['amt2'] = 100 * 500
+            xmldict['amt1'] = 100 * 1000
+            xmldict['amt2'] = 100 * 1000
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
@@ -459,6 +459,6 @@
             # amount_auth is being ignored. However, the sum of all split payments
             # must coincide with the amount_auth configured in students/utils.py
-            xmldict['amt1'] = 100 * 500
-            xmldict['amt2'] = 100 * 500
+            xmldict['amt1'] = 100 * 1000
+            xmldict['amt2'] = 100 * 1000
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
@@ -506,7 +506,7 @@
             # amount_auth is being ignored. However, the sum of all split payments
             # must coincide with the amount_auth configured in students/utils.py
-            xmldict['amt1'] = 100 * 500
+            xmldict['amt1'] = 100 * 1000
             xmldict['amt2'] = 100 * 500
-            xmldict['amt3'] = 100 * 500
+            xmldict['amt3'] = 100 * 1000
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
@@ -521,6 +521,6 @@
             # amount_auth is being ignored. However, the sum of all split payments
             # must coincide with the amount_auth configured in students/utils.py
-            xmldict['amt1'] = 100 * 500
-            xmldict['amt2'] = 100 * 500
+            xmldict['amt1'] = 100 * 1000
+            xmldict['amt2'] = 100 * 1000
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
@@ -534,6 +534,6 @@
             # amount_auth is being ignored. However, the sum of all split payments
             # must coincide with the amount_auth configured in students/utils.py
-            xmldict['amt1'] = 100 * 500
-            xmldict['amt2'] = 100 * 500
+            xmldict['amt1'] = 100 * 1000
+            xmldict['amt2'] = 100 * 1000
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
@@ -547,6 +547,6 @@
             # amount_auth is being ignored. However, the sum of all split payments
             # must coincide with the amount_auth configured in students/utils.py
-            xmldict['amt1'] = 100 * 500
-            xmldict['amt2'] = 100 * 500
+            xmldict['amt1'] = 100 * 1000
+            xmldict['amt2'] = 100 * 1000
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
@@ -560,6 +560,6 @@
             # amount_auth is being ignored. However, the sum of all split payments
             # must coincide with the amount_auth configured in students/utils.py
-            xmldict['amt1'] = 100 * 500
-            xmldict['amt2'] = 100 * 500
+            xmldict['amt1'] = 100 * 1000
+            xmldict['amt2'] = 100 * 1000
             xmldict['amt3'] = 100 * 3000
             xmldict['amt4'] = 100 * 500
@@ -581,6 +581,6 @@
             # amount_auth is being ignored. However, the sum of all split payments
             # must coincide with the amount_auth configured in students/utils.py
-            xmldict['amt1'] = 100 * 500
-            xmldict['amt2'] = 100 * 500
+            xmldict['amt1'] = 100 * 1000
+            xmldict['amt2'] = 100 * 1000
             xmldict['amt3'] = 100 * 3000
             xmltext = """<payment_item_detail>
@@ -596,6 +596,6 @@
             # amount_auth is being ignored. However, the sum of all split payments
             # must coincide with the amount_auth configured in students/utils.py
-            xmldict['amt1'] = 100 * 500
-            xmldict['amt2'] = 100 * 500
+            xmldict['amt1'] = 100 * 1000
+            xmldict['amt2'] = 100 * 1000
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
@@ -609,6 +609,6 @@
             # amount_auth is being ignored. However, the sum of all split payments
             # must coincide with the amount_auth configured in students/utils.py
-            xmldict['amt1'] = 100 * 500
-            xmldict['amt2'] = 100 * 500
+            xmldict['amt1'] = 100 * 1000
+            xmldict['amt2'] = 100 * 1000
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
@@ -622,6 +622,6 @@
             # amount_auth is being ignored. However, the sum of all split payments
             # must coincide with the amount_auth configured in students/utils.py
-            xmldict['amt1'] = 100 * 500
-            xmldict['amt2'] = 100 * 500
+            xmldict['amt1'] = 100 * 1000
+            xmldict['amt2'] = 100 * 1000
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">