Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py	(revision 16758)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py	(revision 16801)
@@ -2004,7 +2004,7 @@
             '\nmsg: The candidate with Id app%s_372052 and name John Anthony Tester applied to'
             '\nmsg: the Sample University to study Unnamed Certificate for the %s/%s session.'
-            '\nmsg: The candidate has listed you as referee. You are thus required to kindly use'
-            '\nmsg: the link below to provide your referral remarks on or before'
-            '\nmsg: 2016-08-12 08:32:41.619671+00:00.'
+            '\nmsg: The candidate has listed you as referee. You are, therefore, required to,'
+            '\nmsg: kindly, provide your referral remarks on or before <YYYY-MM-DD hh:mm:ss>.<6-DIGITS>+00:00. Please use the'
+            '\nmsg: following form:'
             '\nmsg: '
             '\nmsg: Report link: http://localhost/app/mandate?mandate_id=%s'
@@ -2013,5 +2013,5 @@
             '\nmsg: '
             '\nmsg: The Secretary'
-            '\nmsg: Post Graduate School'
+            '\nmsg: School of Postgraduate Studies'
             '\nmsg: Sample University'
             '\nmsg: '
@@ -2030,7 +2030,7 @@
             '\nmsg: The candidate with Id app%s_<6-DIGITS> and name John Anthony Tester applied to'
             '\nmsg: the Sample University to study Unnamed Certificate for the %s/%s session.'
-            '\nmsg: The candidate has listed you as referee. You are thus required to kindly use'
-            '\nmsg: the link below to provide your referral remarks on or before'
-            '\nmsg: <YYYY-MM-DD hh:mm:ss>.<6-DIGITS>+00:00.'
+            '\nmsg: The candidate has listed you as referee. You are, therefore, required to,'
+            '\nmsg: kindly, provide your referral remarks on or before <YYYY-MM-DD hh:mm:ss>.<6-DIGITS>+00:00. Please use the'
+            '\nmsg: following form:'
             '\nmsg: '
             '\nmsg: Report link: http://localhost/app/mandate?mandate_id=%s'
@@ -2039,5 +2039,5 @@
             '\nmsg: '
             '\nmsg: The Secretary'
-            '\nmsg: Post Graduate School'
+            '\nmsg: School of Postgraduate Studies'
             '\nmsg: Sample University'
             '\nmsg: '
@@ -2118,7 +2118,7 @@
             '\nmsg: The candidate with Id app%s_372052 and name Joan Mitchell applied to'
             '\nmsg: the Sample University to study Unnamed Certificate for the %s/%s session.'
-            '\nmsg: The candidate has listed you as referee. You are thus required to kindly use'
-            '\nmsg: the link below to provide your referral remarks on or before'
-            '\nmsg: 2016-08-12 08:32:41.619671+00:00.'
+            '\nmsg: The candidate has listed you as referee. You are, therefore, required to,'
+            '\nmsg: kindly, provide your referral remarks on or before <YYYY-MM-DD hh:mm:ss>.<6-DIGITS>+00:00. Please use the'
+            '\nmsg: following form:'
             '\nmsg: '
             '\nmsg: Report link: http://localhost/app/mandate?mandate_id=%s'
@@ -2127,5 +2127,5 @@
             '\nmsg: '
             '\nmsg: The Secretary'
-            '\nmsg: Post Graduate School'
+            '\nmsg: School of Postgraduate Studies'
             '\nmsg: Sample University'
             '\nmsg: '
@@ -2144,7 +2144,7 @@
             '\nmsg: The candidate with Id app%s_<6-DIGITS> and name Joan Mitchell applied to'
             '\nmsg: the Sample University to study Unnamed Certificate for the %s/%s session.'
-            '\nmsg: The candidate has listed you as referee. You are thus required to kindly use'
-            '\nmsg: the link below to provide your referral remarks on or before'
-            '\nmsg: <YYYY-MM-DD hh:mm:ss>.<6-DIGITS>+00:00.'
+            '\nmsg: The candidate has listed you as referee. You are, therefore, required to,'
+            '\nmsg: kindly, provide your referral remarks on or before <YYYY-MM-DD hh:mm:ss>.<6-DIGITS>+00:00. Please use the'
+            '\nmsg: following form:'
             '\nmsg: '
             '\nmsg: Report link: http://localhost/app/mandate?mandate_id=%s'
@@ -2153,5 +2153,5 @@
             '\nmsg: '
             '\nmsg: The Secretary'
-            '\nmsg: Post Graduate School'
+            '\nmsg: School of Postgraduate Studies'
             '\nmsg: Sample University'
             '\nmsg: '