Index: main/waeup.uniben/trunk/src/waeup/uniben/applicants/browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/applicants/browser.py	(revision 16804)
+++ main/waeup.uniben/trunk/src/waeup/uniben/applicants/browser.py	(revision 16807)
@@ -258,5 +258,5 @@
             #form_fields['perm_address'].custom_widget = BytesDisplayWidget
             return form_fields
-        if self.target is not None and self.target == 'french':
+        if self.target is not None and self.target == 'flc':
             form_fields = grok.AutoFields(IFrenchApplicant)
             for field in REGISTRATION_OMIT_DISPLAY_FIELDS:
@@ -458,5 +458,5 @@
                 form_fields['registration_cats'].for_display = True
             return form_fields
-        if self.target is not None and self.target == 'french':
+        if self.target is not None and self.target == 'flc':
             form_fields = grok.AutoFields(IFrenchApplicant)
             for field in REGISTRATION_OMIT_MANAGE_FIELDS:
@@ -543,5 +543,5 @@
                 form_fields['registration_cats'].for_display = True
             return form_fields
-        if self.target is not None and self.target == 'french':
+        if self.target is not None and self.target == 'flc':
             form_fields = grok.AutoFields(IFrenchApplicant)
             for field in REGISTRATION_OMIT_EDIT_FIELDS:
@@ -721,5 +721,5 @@
                 for field in PUDE_OMIT_PDF_FIELDS:
                     form_fields = form_fields.omit(field)
-        elif self.target is not None and self.target == 'french':
+        elif self.target is not None and self.target == 'flc':
             form_fields = grok.AutoFields(IFrenchApplicant)
             for field in REGISTRATION_OMIT_PDF_FIELDS:
Index: main/waeup.uniben/trunk/src/waeup/uniben/applicants/interfaces.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/applicants/interfaces.py	(revision 16804)
+++ main/waeup.uniben/trunk/src/waeup/uniben/applicants/interfaces.py	(revision 16807)
@@ -146,5 +146,5 @@
     """
     def getValues(self):
-        return ['n', 'c', 'p']
+        return ['c', 'p']
 
     def getToken(self, value):
@@ -152,10 +152,27 @@
 
     def getTitle(self, value):
-        if value == 'n':
-            return _('none')
+        #if value == 'n':
+        #    return _('none')
         if value == 'c':
             return _('conversational')
-        if value == 'c':
+        if value == 'p':
             return _('professional')
+
+class PreferredSessionSource(BasicSourceFactory):
+    """
+    """
+    def getValues(self):
+        return ['m', 'e', 'w']
+
+    def getToken(self, value):
+        return value
+
+    def getTitle(self, value):
+        if value == 'm':
+            return _('morning')
+        if value == 'e':
+            return _('evening')
+        if value == 'w':
+            return _('weekend')
 
 class IUnibenRegistration(IKofaObject):
@@ -547,4 +564,11 @@
         show_year = True,
         )
+
+    pref_session = schema.Choice(
+        source = PreferredSessionSource(),
+        title = _(u'Preferred Session'),
+        required = False,
+        )
+
     proficiency = schema.Choice(
         source = ProficiencySource(),
Index: main/waeup.uniben/trunk/src/waeup/uniben/applicants/utils.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/applicants/utils.py	(revision 16804)
+++ main/waeup.uniben/trunk/src/waeup/uniben/applicants/utils.py	(revision 16807)
@@ -68,5 +68,5 @@
         'tscf': ['Transcript (without student record)', 'TRF'],
         'tscs': ['Transcript (with student record)', 'TRS'],
-        'french': ['French Language Centre', 'FR'],
+        'flc': ['French Language Centre', 'FR'],
         }
 
Index: main/waeup.uniben/trunk/src/waeup/uniben/utils/utils.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/utils/utils.py	(revision 16804)
+++ main/waeup.uniben/trunk/src/waeup/uniben/utils/utils.py	(revision 16807)
@@ -57,4 +57,5 @@
         'special_ft': 'Special Full-Time',
         'cdl': 'Center For Distance Learning',
+        'french': 'French Language Center',
         }
 