Index: main/waeup.fceokene/trunk/src/waeup/fceokene/applicants/schools_pandemic.py
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/applicants/schools_pandemic.py	(revision 16854)
+++ main/waeup.fceokene/trunk/src/waeup/fceokene/applicants/schools_pandemic.py	(revision 16861)
@@ -227,3 +227,36 @@
     's0226': ('Zone 15','Okpella-Auchi','Caliphate Academy, Auchi'),
     's0227': ('Zone 15','Okpella-Auchi','Etsako West Primary Council, Auchi'),
+
+    # Additional School 03/03/2022
+    's2019': ('Zone 11','Lokoja','Truth and Grace Nursery and Primary School, Poly Village Felele, Lokoja, Kogi State'),
+    's2020': ('Zone 11','Lokoja','Edino Prupent International School, beside town planning office, zariagi, kabba junction, lokoja kogi state'),
+    's2021': ('Zone 08','Ikare','Precious Christ foundation nursery/primary school, Ayede quarters ikakumo akoko, ondo state'),
+    's2022': ('Zone 08','Ikare','Olaoluwa solid foundation nursery and primary school, akoko north west local government, ondo, state'),
+    's2023': ('Zone 08','Ikare','African church unity secondary school, epinmi akoko, ondo state'),
+    's2024': ('Zone 08','Ikare','Ogoso high school, Oka - Akoko, p.m.b 3, oka-akoko south west'),
+    's2025': ('Zone 08','Ikare','FUTURE LEADERS ACADEMY, itobe-Ofu LGA, Kogi State'),
+    's2026': ('Zone 01','Otite, Ogaminana, Obangede','Homeland academy, Ohindere community, oziokutu ogaminana new layout adavi l.g.a, kogi state'),
+    's2027': ('Zone 01','Otite, Ogaminana, Obangede','UBE/JSS ozuri, Ogaminana'),
+    's2028': ('Zone 01','Otite, Ogaminana, Obangede','government day secondary school, okunchi-ogaminana'),
+    's2029': ('Zone 01','Otite, Ogaminana, Obangede','Okehi local government Model Secondary school, obangede okehi, kogi state'),
+    's2030': ('Zone 01','Otite, Ogaminana, Obangede','Al-Adabiyyah academy,  ireokovi quarters eika ohizenyi, okehi lga, kogi state'),
+    's2031': ('Zone 01','Otite, Ogaminana, Obangede','Al-Adabiyyah academy,  ireokovi quarters eika ohizenyi, okehi lga, kogi state'),
+    's2032': ('Zone 01','Otite, Ogaminana, Obangede','Achievers nursery and primary school, oziokutu-ogaminana'),
+    's2033': ('Zone 01','Otite, Ogaminana, Obangede','Achievers secondary school, ogaminana'),
+    's2034': ('zone 07','Kabba Aiyetoro Gbedde','Tirenioluwa model college, ipedola close, fehintioluwa, kabba, kogi state'),
+    's2035': ('zone 07','Kabba Aiyetoro Gbedde','Immaculate academy, Fehinitioluwa annex 2, km 1 along ayere/kabba-akure road, kabba, kogi state'),
+    's2036': ('zone 07','Kabba Aiyetoro Gbedde','The peculiar\'s academy, along deeper life,camp ground, odulu, kabba, kogi state'),
+    's2037': ('Zone 04','Okengwe Ihima','L.G.E.A Standard nursery & primary school, Eika-oku okengwe'),
+    's2038': ('Zone 05','Adogo Ajaokuta','Dahrul-Arqam Basic School, Adogo'),
+    's2039': ('Zone 01','Otite, Ogaminana, Obangede','LGEA Oguda, Okene'),
+    's2040': ('Zone 01','Otite, Ogaminana, Obangede','De Heros International Nursery & Primary School, along Nagazi hotel, Nagazi'),
+    's2041': ('Zone 04','Okengwe Ihima','Joyous academy secondary school, oboroke-ihima, okehi, kogi state'),
+    's2042': ('Zone 04','Okengwe Ihima','LGEA St, paul\'s school, ohieka adavi-eba'),
+    's2043': ('Zone 04','Okengwe Ihima','Glory land international academy, behind odumson filling station, oboroke, ihima'),
+    's2044': ('Zone 04','Okengwe Ihima','Future-ray schools, 19 and 85 Dr Jimoh Akpoti street, lniku obeiba, ihima'),
+    's2045': ('Zone 08','Ikare','Olaoluwa solid foundation nursery and primary school, Okeagbe akoko north west local government, ondo, state'),
+    's2046': ('Zone 01','Otite, Ogaminana, Obangede','LGEA Demonstration Nursery and Primary School, Eika-Ohizenyi Okehi, Kogi State'),
+
+    's2047': ('Zone 01','Otite, Ogaminana, Obangede','Brighter tomorrow academy, nagazi uvete'),
+    's2048': ('Zone 01','Otite, Ogaminana, Obangede','De-Majesty comprehensive Nur/Pri school. Along home - master bakery oziokutu kabba junction, ogaminana'),
 }